unit Plane;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Mathimge;

type
  TPlaneGraphs = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    F1line: TEdit;
    F2line: TEdit;
    Button2: TButton;
    Label3: TLabel;
    Meshline: TEdit;
    ColorDialog1: TColorDialog;
    Periods: TLabel;
    Pline: TEdit;
    CheckBox1: TCheckBox;
    Panel2: TPanel;
    xshow: TLabel;
    yshow: TLabel;
    GraphImage: tMathImage;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure GraphImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    graphcolor:longint;
    function getf1:double;
    function getf2:double;
    function getp:double;
    function getmesh:integer;
    function r(o:double):double;
    { Private declarations }
  public
    property f1:double read getf1 ;
    property f2:double read getf2 ;
    property mesh:integer read getmesh;
    property p:double read getp;
    { Public declarations }
  end;

var
  PlaneGraphs: TPlaneGraphs;

implementation

{$R *.DFM}

function TPlaneGraphs.getf1;
var x:double; c:integer;
begin
  val(f1line.text,x,c);
  if c=0 then getf1:=x;
end;

function TPlaneGraphs.getf2;
var x:double; c:integer;
begin
  val(f2line.text,x,c);
  if c=0 then getf2:=x;
end;

function TPlaneGraphs.getp;
var x:double; c:integer;
begin
  val(pline.text,x,c);
  if c=0 then getp:=x;
end;

function TPlaneGraphs.getmesh;
var i,c:integer;
begin
  val(meshline.text,i,c);
  if c=0 then getmesh:=i;
end;

function TPlaneGraphs.r;
begin
  r:=sin(o*f1)+cos(o*f2);
end;


procedure TPlaneGraphs.Button2Click(Sender: TObject);
begin
  with colordialog1 do
  if execute then graphcolor:=color;
end;

procedure TPlaneGraphs.Button1Click(Sender: TObject);
var i:integer; o:double;
begin
  with graphimage do
  begin
    clear;
    setcolor(graphcolor);
    if checkbox1.checked then
    drawaxes(0.1,true,clblack,clred);
    movetopoint(r(0),0);
    for i:=1 to mesh do
    begin
      o:=i*2*p*Pi/mesh;
      drawlineto(r(o)*cos(o),r(o)*sin(o));
    end;
  end;
end;

procedure TPlaneGraphs.FormActivate(Sender: TObject);
begin
  graphcolor:=clolive;
end;

procedure TPlaneGraphs.FormResize(Sender: TObject);
begin
  graphimage.resetworld;
end;


procedure TPlaneGraphs.GraphImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
  var xx:double; s:string;
begin
  with GraphImage do
  begin
    xx:=worldx(x); str(xx:6:4,s); xshow.caption:=s;
    xx:=worldy(y); str(xx:6:4,s); yshow.caption:=s;
  end;
end;

end.
